// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: DummyResponse
// Author: Hassan Siddiqui
//
// Description: 
// Provides a clean interface to Dummy response data.
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: DummyResponse.h,v 1.14 2000/09/21 15:34:35 hsiddiqu Exp $

#ifndef DummyResponse_H
#define DummyResponse_H

/* General classes */

/* SAS-specific classes */
#include "Dal.h"

/* Utility functions */

/* Local classes */
#include "GenericResponse.h"

/*****************************
 *
 * class DummyResponse
 *
 * Interface to Dummy response data.
 *
 *****************************/


class DummyResponse : public GenericResponse
{

public:

  /* Constructor */

  DummyResponse( unsigned int nchannels, 
		 double energyLowKeV,
		 double energyHighKeV,
		 unsigned int numberOfEbins 
		 );

  ~DummyResponse();

  /** Channel range accessors */
  const unsigned int   firstChannel()     const;
  const unsigned int   lastChannel()      const;


  /** Response Accessors */
  unsigned int numberOfEbins()    const;

  const Bin ebins (unsigned int row) const;

  const vector<double>  responseVector ( unsigned int energy_iterator ) const;

  const vector<double>  responseVector ( double energy ) const;
 
  /** Ebounds Accessors */
  const BinnedAxis * ebounds()  const;

  unsigned int    energyToPha( double energy ) const;

private:

  double _energyLow;
  double _energyHigh;
  unsigned int _numberOfEbins;

  unsigned int _firstChannel;
  unsigned int _lastChannel;

  BinnedAxis *_ebins;
  BinnedAxis *_ebounds;

  /** Constants */
  static const double GAUSSIAN_SIGMA = 10;
  static const double _ENERGYRES_CONST = 1.7;

};

#endif




